
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	AMPL	((double)((maxsin - minsin)/2))	/* Amplitude */

int
main(int argc, char *argv[])
{
	int i,s;
	int minsin, maxsin;

	if (argc != 3) {
		printf("Usage: sin_table minsin maxsin\n");
		exit(1);
	}
	minsin = strtol(argv[1], NULL, 16);
	maxsin = strtol(argv[2], NULL, 16);

	printf("/* Sine table\n");
	printf(" * Minimum value = 0x%02x\n", minsin);
	printf(" * Maximum value = 0x%02x\n", maxsin);
	printf(" */\n");
	printf("const uint8_t  sinewave[] PROGMEM = { //256 values");

	for(i=0; i<256; i++) {
		s = 0x80 + (int)(AMPL * sin(2.0*M_PI*(double)i/256.0));
		if ((i%8) == 0) {
			printf("\n\t");
		}
		printf("0x%02x,",s);
	}
	printf("\n};\n");
}
